#ifndef SNP_DIVFILE_H
#define SNP_DIVFILE_H

#include <stdio.h>
#include "snp_typeI.h"
#include "SNP_DivFileXML.h"

#define SNP_DATA_BASE_SIZE 70


// 分割データファイル/ヘッダ情報構造体
typedef struct SNP_DivData_Head_ {
  long blockNum;
  long totalSNPNum;
  long *SNPStart;
  long *SNPNum;
} SNP_DivData_Head;

void Init_SNP_DivData_Head(SNP_DivData_Head* phead);
void Clear_SNP_DivData_Head(SNP_DivData_Head* phead);
int Read_SNP_DivData_Head(FILE *fp, SNP_DivData_Head* phead);

int Read_SNPdata(FILE *fp, SnpData* data, long sampleNum);

int Skip_To_CaseData(FILE *fp, long caseIdx);
int Skip_To_ControlData(FILE *fp, long controlIdx);
int Skip_To_BlockArea(FILE *fp, long blockAreaIdx);

int Link_SNP_DivData(SNP_DivFileSet *divFileSet,
		     int start_FileIdx, int end_fileIdx,
		     long start_blockIdx, long end_blockIdx,
		     long *linkSNPStart, long *linkSNPNum, long *dataNum);

int Check_BlockAreaRange(SNP_DivFileSet* divFileSet,
			 long blockPartStart, long blockPartNum,
			 int *start_FileIdx, long *start_blockIdx,
			 int *end_fileIdx, long *end_blockIdx);


int Read_SNP_DivData(SNP_DivFileSet *divFileSet,
		     int start_FileIdx, int end_fileIdx,
		     long start_blockIdx, long end_blockIdx,
		     SnpData *snpData1, SnpData *snpData2, long *blockArea);

#endif // SNP_DIVFILE_H
