#ifndef SNP_DIVFILEXML_H
#define SNP_DIVFILEXML_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SNP_PATH_LEN 1024

// 分割データファイル情報構造体
typedef struct SNP_DivFile_ {
  long blockPartStart;
  long blockPartNum;
  char path[SNP_PATH_LEN];
} SNP_DivFile;

void Init_SNP_DivFile(SNP_DivFile* pdata);


// データ分割情報構造体
typedef struct SNP_DivFileSet_ {
  char progName[64];

  int caseDataType;
  long caseSampleNum;
  char caseFileName[SNP_PATH_LEN];

  int controlDataType;
  long controlSampleNum;
  char controlFileName[SNP_PATH_LEN];

  int blockAreaType;
  char blockAreaFileName[SNP_PATH_LEN];

  long dataNum;
  long blockNum;

  int divNum;
  char baseDirName[SNP_PATH_LEN];
  SNP_DivFile *snpFileList;
} SNP_DivFileSet;

void Init_SNP_DivFileSet(SNP_DivFileSet* pdset);

int Alloc_SNP_DivFileSet(SNP_DivFileSet* pdset, long num);

void Clear_SNP_DivFileSet(SNP_DivFileSet* pdset);

int ParseXMLFile(char *fileName, SNP_DivFileSet* divFileSet);

#endif // SNP_DIVFILEXML_H
